unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,  StdCtrls, ExtCtrls, directshow9, ActiveX, Jpeg, WinInet, IniFiles;


type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Panel1: TPanel;
    Button1: TButton;
    Panel2: TPanel;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit6: TEdit;
    Label6: TLabel;
    Label8: TLabel;
    Button2: TButton;
    Timer1: TTimer;
    Edit5: TEdit;
    Label5: TLabel;
    Button3: TButton;
    Label4: TLabel;
    Edit4: TEdit;
    Edit7: TEdit;
    Label7: TLabel;
    Label9: TLabel;
    function CreateGraph: HResult;
    function Initializ: HResult;
    function CaptureBitmap: HResult;
    procedure LoadIniFiles;
    procedure SaveIniFiles;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SendFtp;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  IniFile: TIniFile;
  FileName: string;
  RecMode: boolean = False;
  DeviceName:OleVariant;
  PropertyName:IPropertyBag;
  pDevEnum:ICreateDEvEnum;
  pEnum:IEnumMoniker;
  pMoniker:IMoniker;

MArray1: array of IMoniker; //  ,  
//     


//
    FGraphBuilder:        IGraphBuilder;
    FCaptureGraphBuilder: ICaptureGraphBuilder2;
    FMux:                 IBaseFilter;
    FSink:                IFileSinkFilter;
    FMediaControl:        IMediaControl;
    FVideoWindow:         IVideoWindow;
    FVideoCaptureFilter:  IBaseFilter;
    FAudioCaptureFilter:  IBaseFilter;
//  
    FVideoRect:           TRect;

    FBaseFilter:          IBaseFilter;
    FSampleGrabber:       ISampleGrabber;
    MediaType:            AM_MEDIA_TYPE;


implementation

{$R *.dfm}

function TForm1.Initializ: HResult;
begin
//    
Result:=CoCreateInstance(CLSID_SystemDeviceEnum, NIL, CLSCTX_INPROC_SERVER,
IID_ICreateDevEnum, pDevEnum);
if Result<>S_OK then EXIT;

//  Video
Result:=pDevEnum.CreateClassEnumerator(CLSID_VideoInputDeviceCategory, pEnum, 0);
if Result<>S_OK then EXIT;
//    
setlength(MArray1,0);
//    
while (S_OK=pEnum.Next(1,pMoniker,Nil)) do
begin
setlength(MArray1,length(MArray1)+1); //   
MArray1[length(MArray1)-1]:=pMoniker; //   
Result:=pMoniker.BindToStorage(NIL, NIL, IPropertyBag, PropertyName); //      IPropertyBag
if FAILED(Result) then Continue;
Result:=PropertyName.Read('FriendlyName', DeviceName, NIL); //  
if FAILED(Result) then Continue;
//    
Listbox1.Items.Add(DeviceName);
end;

//     
//   
if ListBox1.Count=0 then
   begin
      ShowMessage('  ');
      Result:=E_FAIL;;
      Exit;
   end;
Listbox1.ItemIndex:=0;
//  
Result:=S_OK;
end;

function TForm1.CreateGraph:HResult;
var
  pConfigMux: IConfigAviMux;
begin
// 
  FVideoCaptureFilter  := NIL;
  FVideoWindow         := NIL;
  FMediaControl        := NIL;
  FSampleGrabber       := NIL;
  FBaseFilter          := NIL;
  FCaptureGraphBuilder := NIL;
  FGraphBuilder        := NIL;

//    
Result:=CoCreateInstance(CLSID_FilterGraph, NIL, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, FGraphBuilder);
if FAILED(Result) then EXIT;
//    
Result:=CoCreateInstance(CLSID_SampleGrabber, NIL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, FBaseFilter);
if FAILED(Result) then EXIT;
//    
Result:=CoCreateInstance(CLSID_CaptureGraphBuilder2, NIL, CLSCTX_INPROC_SERVER, IID_ICaptureGraphBuilder2, FCaptureGraphBuilder);
if FAILED(Result) then EXIT;

//    
Result:=FGraphBuilder.AddFilter(FBaseFilter, 'GRABBER');
if FAILED(Result) then EXIT;
//    
Result:=FBaseFilter.QueryInterface(IID_ISampleGrabber, FSampleGrabber);
if FAILED(Result) then EXIT;

  if FSampleGrabber <> NIL then
  begin
    //      
    ZeroMemory(@MediaType, sizeof(AM_MEDIA_TYPE));

    with MediaType do
    begin
      majortype  := MEDIATYPE_Video;
      subtype    := MEDIASUBTYPE_RGB24;
      formattype := FORMAT_VideoInfo;
    end;

    FSampleGrabber.SetMediaType(MediaType);

    //        ,   
    //   
    FSampleGrabber.SetBufferSamples(TRUE);

    //       
    FSampleGrabber.SetOneShot(FALSE);
  end;

//  
Result:=FCaptureGraphBuilder.SetFiltergraph(FGraphBuilder);
if FAILED(Result) then EXIT;

//  ListBox - 
if Listbox1.ItemIndex>=0 then
           begin
              //       
              MArray1[Listbox1.ItemIndex].BindToObject(NIL, NIL, IID_IBaseFilter, FVideoCaptureFilter);
              //    
              FGraphBuilder.AddFilter(FVideoCaptureFilter, 'VideoCaptureFilter'); //   
           end;

//,         
Result:=FCaptureGraphBuilder.RenderStream(@PIN_CATEGORY_PREVIEW, nil, FVideoCaptureFilter ,FBaseFilter  ,nil);
if FAILED(Result) then EXIT;

//    
Result:=FGraphBuilder.QueryInterface(IID_IVideoWindow, FVideoWindow);
if FAILED(Result) then EXIT;
//   
FVideoWindow.put_WindowStyle(WS_CHILD or WS_CLIPSIBLINGS);
//     Panel1
FVideoWindow.put_Owner(Panel1.Handle);
//     
FVideoRect:=Panel1.ClientRect;
FVideoWindow.SetWindowPosition(FVideoRect.Left,FVideoRect.Top, FVideoRect.Right - FVideoRect.Left,FVideoRect.Bottom - FVideoRect.Top);
// 
FVideoWindow.put_Visible(TRUE);

//   
Result:=FGraphBuilder.QueryInterface(IID_IMediaControl, FMediaControl);
if FAILED(Result) then Exit;
//    
FMediaControl.Run();
end;

function TForm1.CaptureBitmap: HResult;
var
  bSize: integer;
  pVideoHeader: TVideoInfoHeader;
  MediaType: TAMMediaType;
  BitmapInfo: TBitmapInfo;
  Buffer: Pointer;
  tmp: array of byte;
  Bitmap: TBitmap;
  JpegIm: TJpegImage;
begin
  //   
  Result := E_FAIL;

  //       ,
  //   
  if FSampleGrabber = NIL then EXIT;

  //   
    Result := FSampleGrabber.GetCurrentBuffer(bSize, NIL);
    if (bSize <= 0) or FAILED(Result) then EXIT;
  //  
  Bitmap := TBitmap.Create;
  try
  //         
  ZeroMemory(@MediaType, sizeof(TAMMediaType));
  Result := FSampleGrabber.GetConnectedMediaType(MediaType);
  if FAILED(Result) then EXIT;

    //   
    pVideoHeader := TVideoInfoHeader(MediaType.pbFormat^);
    ZeroMemory(@BitmapInfo, sizeof(TBitmapInfo));
    CopyMemory(@BitmapInfo.bmiHeader, @pVideoHeader.bmiHeader, sizeof(TBITMAPINFOHEADER));

    Buffer := NIL;

    //   
    Bitmap.Handle := CreateDIBSection(0, BitmapInfo, DIB_RGB_COLORS, Buffer, 0, 0);

    //     
    SetLength(tmp, bSize);

    try
      //        
      FSampleGrabber.GetCurrentBuffer(bSize, @tmp[0]);

      //        
      CopyMemory(Buffer, @tmp[0], MediaType.lSampleSize);

      //     bmp 
      //Bitmap.SaveToFile(' .bmp');

      //    Jpeg
      //  JpegImage
      JpegIm := TJpegImage.Create;
      //    Bitmap
      JpegIm.Assign(Bitmap);
      //  
      JpegIm.CompressionQuality := 30;
      //
      JpegIm.Compress;
      //  
      FileName:=Edit7.Text;
      JpegIm.SaveToFile(FileName);

    except

      //      
      Result := E_FAIL;
    end;
  finally
    //  
    SetLength(tmp, 0);
    Bitmap.Free;
    JpegIm.Free;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
//     
if Listbox1.Count=0 then
    Begin
      ShowMessage('!   .');
      Exit;
    End;
//     
if FAILED(CaptureBitmap) then
    Begin
      ShowMessage('!     ');
      Exit;
    End;
Label9.Caption:='  ';
SendFtp;
//    
Timer1.Interval:=StrToInt(Edit6.Text)*1000;
Timer1.Enabled:=True;
end;

procedure TForm1.Button1Click(Sender: TObject);
//   Web-
var
  StreamConfig: IAMStreamConfig;
  PropertyPages: ISpecifyPropertyPages;
  Pages: CAUUID;
Begin
//    - 
If RecMode then Exit;
  //      ,   
  if FVideoCaptureFilter = NIL then EXIT;
  //   
  FMediaControl.Stop;
  try
    //       
    //   ,  ...
    if SUCCEEDED(FCaptureGraphBuilder.FindInterface(@PIN_CATEGORY_CAPTURE,
      @MEDIATYPE_Video, FVideoCaptureFilter, IID_IAMStreamConfig, StreamConfig)) then
    begin
      // ...       ...
      // ... ,   ,  ...
      if SUCCEEDED(StreamConfig.QueryInterface(ISpecifyPropertyPages, PropertyPages)) then
      begin
        // ...    
        PropertyPages.GetPages(Pages);
        PropertyPages := NIL;

        //       
        OleCreatePropertyFrame(
           Handle,
           0,
           0,
           PWideChar(ListBox1.Items.Strings[listbox1.ItemIndex]),
           1,
           @StreamConfig,
           Pages.cElems,
           Pages.pElems,
           0,
           0,
           NIL
        );

        //  
        StreamConfig := NIL;
        CoTaskMemFree(Pages.pElems);
      end;
    end;

  finally
    //   
    FMediaControl.Run;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
Label9.Caption:='  ';
Timer1.Enabled:=False;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
//   ini 
LoadIniFiles;
CoInitialize(nil);//  OLE COM
//         
if FAILED(Initializ) then
    Begin
      ShowMessage('!    ');
      Exit;
    End;
//   
if Listbox1.Count>0 then
    Begin
        //     ,
        //     
        if FAILED(CreateGraph) then
            Begin
              ShowMessage('!      ');
              Exit;
            End;
    end else
            Begin
              ShowMessage('!   .');
              //Application.Terminate;
            End;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
//  
        pEnum := NIL;
        pDevEnum := NIL;
        pMoniker := NIL;
        PropertyName := NIL;
        DeviceName:=Unassigned;
        CoUninitialize;//  OLE COM
//   inifile
SaveIniFiles;
IniFile.Free;
end;


//   ListBox1
procedure TForm1.ListBox1DblClick(Sender: TObject);
begin
if ListBox1.Count=0 then
    Begin
       ShowMessage('  ');
       Exit;
    End;
//     
if FAILED(CreateGraph) then
    Begin
      ShowMessage('!      ');
      Exit;
    End;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
// 
if FAILED(CaptureBitmap) then
    Begin
      ShowMessage('!     ');
      Exit;
    End;
//     FTP
SendFtp;
end;

//   FTP
procedure TForm1.SendFtp;
var Username,Password,Folder, Port, Server:String;
inet_open, conn_param :pointer;
begin
//   FTP
  Folder:=Edit5.Text;
  Username:=Edit2.Text;
  Password:=Edit3.Text;
  Port:=Edit4.Text;
  Server:=Edit1.Text;
  FileName:=Edit7.Text;
//    Image1
  Image1.Picture.LoadFromFile(FileName);
  //  
  inet_open:= internetopen('iexplore',INTERNET_OPEN_TYPE_DIRECT,nil,nil,0);
  //  FTP 
  conn_param:=internetconnect(inet_open,PChar(Server),strtoint(Port),PChar(Username),PChar(Password),INTERNET_SERVICE_FTP,INTERNET_FLAG_PASSIVE,0);
  //    
  FtpSetCurrentDirectory(conn_param, PChar(Folder));
  //   FTP
  if ftpputfile(conn_param,PChar(FileName),PChar(FileName),FTP_TRANSFER_TYPE_UNKNOWN,0)=false then
  begin
  ShowMessage('.   !');
  Label9.Caption:='  ';
  Timer1.Enabled:=false;
  end;
  //      
  beep;
  // 
  internetclosehandle(conn_param);
  internetclosehandle(inet_open) ;
end;

procedure TForm1.LoadIniFiles;
begin
// inifile    Config.ini
IniFile:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'config.ini');
//   inifile
//   
  Form1.Left:=IniFile.ReadInteger('Form info','Left',285);
  Form1.Top:=IniFile.ReadInteger('Form info','Top',168);
// FTP 
  Edit1.Text:=IniFile.ReadString('FTP','Host','');
  Edit2.Text:=IniFile.ReadString('FTP','UserName','');
  Edit3.Text:=IniFile.ReadString('FTP','Password','');
  Edit4.Text:=IniFile.ReadString('FTP','Port','21');
  Edit5.Text:=IniFile.ReadString('FTP','Folder','/');
  Edit6.Text:=IniFile.ReadString('FTP','Interval','20');
  Edit7.Text:=IniFile.ReadString('FTP','FileName','');
end;

procedure TForm1.SaveIniFiles;
begin
//   inifile
//
  IniFile.WriteInteger('Form info','Left',Left);
  IniFile.WriteInteger('Form info','Top',Top);
// FTP 
  IniFile.WriteString('FTP','Host',Edit1.Text);
  IniFile.WriteString('FTP','UserName',Edit2.Text);
  IniFile.WriteString('FTP','Password',Edit3.Text);
  IniFile.WriteString('FTP','Port',Edit4.Text);
  IniFile.WriteString('FTP','Folder',Edit5.Text);
  IniFile.WriteString('FTP','Interval',Edit6.Text);
  IniFile.WriteString('FTP','FileName',Edit7.Text);
end;

end.
